build system tests: Untabify shell script

This commit is contained in:
Angus Gratton 2016-10-06 18:06:52 +11:00
parent f720e82d40
commit 6a890e6c49

View File

@ -32,123 +32,123 @@ export V=1
function run_tests() function run_tests()
{ {
FAILURES= FAILURES=
STATUS="Starting" STATUS="Starting"
print_status "Checking prerequisites" print_status "Checking prerequisites"
[ -z ${IDF_PATH} ] && echo "IDF_PATH is not set. Need path to esp-idf installation." && exit 2 [ -z ${IDF_PATH} ] && echo "IDF_PATH is not set. Need path to esp-idf installation." && exit 2
print_status "Cloning template from ${ESP_IDF_TEMPLATE_GIT}..." print_status "Cloning template from ${ESP_IDF_TEMPLATE_GIT}..."
git clone ${ESP_IDF_TEMPLATE_GIT} template git clone ${ESP_IDF_TEMPLATE_GIT} template
cd template cd template
git checkout ${CI_BUILD_REF_NAME} || echo "Using esp-idf-template default branch..." git checkout ${CI_BUILD_REF_NAME} || echo "Using esp-idf-template default branch..."
print_status "Updating template config..." print_status "Updating template config..."
make defconfig || exit $? make defconfig || exit $?
BOOTLOADER_BINS="bootloader/bootloader.elf bootloader/bootloader.bin" BOOTLOADER_BINS="bootloader/bootloader.elf bootloader/bootloader.bin"
APP_BINS="app-template.elf app-template.bin" APP_BINS="app-template.elf app-template.bin"
print_status "Initial clean build" print_status "Initial clean build"
# if make fails here, everything fails # if make fails here, everything fails
make || exit $? make || exit $?
# check all the expected build artifacts from the clean build # check all the expected build artifacts from the clean build
assert_built ${APP_BINS} ${BOOTLOADER_BINS} partitions_singleapp.bin assert_built ${APP_BINS} ${BOOTLOADER_BINS} partitions_singleapp.bin
[ -f ${BUILD}/partition*.bin ] || failure "A partition table should have been built" [ -f ${BUILD}/partition*.bin ] || failure "A partition table should have been built"
print_status "Updating component source file rebuilds component" print_status "Updating component source file rebuilds component"
# touch a file & do a build # touch a file & do a build
take_build_snapshot take_build_snapshot
touch ${IDF_PATH}/components/esp32/syscalls.c touch ${IDF_PATH}/components/esp32/syscalls.c
make || failure "Failed to partial build" make || failure "Failed to partial build"
assert_rebuilt ${APP_BINS} esp32/libesp32.a esp32/syscalls.o assert_rebuilt ${APP_BINS} esp32/libesp32.a esp32/syscalls.o
assert_not_rebuilt lwip/liblwip.a freertos/libfreertos.a ${BOOTLOADER_BINS} partitions_singleapp.bin assert_not_rebuilt lwip/liblwip.a freertos/libfreertos.a ${BOOTLOADER_BINS} partitions_singleapp.bin
print_status "Bootloader source file rebuilds bootloader" print_status "Bootloader source file rebuilds bootloader"
take_build_snapshot take_build_snapshot
touch ${IDF_PATH}/components/bootloader/src/main/bootloader_start.c touch ${IDF_PATH}/components/bootloader/src/main/bootloader_start.c
make bootloader || failure "Failed to partial build bootloader" make bootloader || failure "Failed to partial build bootloader"
assert_rebuilt ${BOOTLOADER_BINS} bootloader/main/bootloader_start.o assert_rebuilt ${BOOTLOADER_BINS} bootloader/main/bootloader_start.o
assert_not_rebuilt ${APP_BINS} partitions_singleapp.bin assert_not_rebuilt ${APP_BINS} partitions_singleapp.bin
print_status "Partition CSV file rebuilds partitions" print_status "Partition CSV file rebuilds partitions"
take_build_snapshot take_build_snapshot
touch ${IDF_PATH}/components/partition_table/partitions_singleapp.csv touch ${IDF_PATH}/components/partition_table/partitions_singleapp.csv
make partition_table || failure "Failed to build partition table" make partition_table || failure "Failed to build partition table"
assert_rebuilt partitions_singleapp.bin assert_rebuilt partitions_singleapp.bin
assert_not_rebuilt app-template.bin app-template.elf ${BOOTLOADER_BINS} assert_not_rebuilt app-template.bin app-template.elf ${BOOTLOADER_BINS}
print_status "Partial build doesn't compile anything by default" print_status "Partial build doesn't compile anything by default"
take_build_snapshot take_build_snapshot
# verify no build files are refreshed by a partial make # verify no build files are refreshed by a partial make
ALL_BUILD_FILES=$(find ${BUILD} -type f | sed "s@${BUILD}/@@") ALL_BUILD_FILES=$(find ${BUILD} -type f | sed "s@${BUILD}/@@")
make || failure "Partial build failed" make || failure "Partial build failed"
assert_not_rebuilt ${ALL_BUILD_FILES} assert_not_rebuilt ${ALL_BUILD_FILES}
print_status "Cleaning should remove all files from build" print_status "Cleaning should remove all files from build"
make clean || failure "Failed to make clean" make clean || failure "Failed to make clean"
ALL_BUILD_FILES=$(find ${BUILD} -type f) ALL_BUILD_FILES=$(find ${BUILD} -type f)
if [ -n "${ALL_BUILD_FILES}" ]; then if [ -n "${ALL_BUILD_FILES}" ]; then
failure "Files weren't cleaned: ${ALL_BUILD_FILES}" failure "Files weren't cleaned: ${ALL_BUILD_FILES}"
fi fi
print_status "Moving BUILD_DIR_BASE out of tree" print_status "Moving BUILD_DIR_BASE out of tree"
rm -rf --preserve-root ${BUILD}/* rm -rf --preserve-root ${BUILD}/*
OUTOFTREE_BUILD=${TESTDIR}/alt_build OUTOFTREE_BUILD=${TESTDIR}/alt_build
make BUILD_DIR_BASE=${OUTOFTREE_BUILD} || failure "Failed to build with BUILD_DIR_BASE overriden" make BUILD_DIR_BASE=${OUTOFTREE_BUILD} || failure "Failed to build with BUILD_DIR_BASE overriden"
NEW_BUILD_FILES=$(find ${OUTOFREE_BUILD} -type f) NEW_BUILD_FILES=$(find ${OUTOFREE_BUILD} -type f)
if [ -z "${NEW_BUILD_FILES}" ]; then if [ -z "${NEW_BUILD_FILES}" ]; then
failure "No files found in new build directory!" failure "No files found in new build directory!"
fi fi
DEFAULT_BUILD_FILES=$(find ${BUILD} -mindepth 1) DEFAULT_BUILD_FILES=$(find ${BUILD} -mindepth 1)
if [ -n "${DEFAULT_BUILD_FILES}" ]; then if [ -n "${DEFAULT_BUILD_FILES}" ]; then
failure "Some files were incorrectly put into the default build directory: ${DEFAULT_BUILD_FILES}" failure "Some files were incorrectly put into the default build directory: ${DEFAULT_BUILD_FILES}"
fi fi
print_status "BUILD_DIR_BASE inside default build directory" print_status "BUILD_DIR_BASE inside default build directory"
rm -rf --preserve-root ${BUILD}/* rm -rf --preserve-root ${BUILD}/*
make BUILD_DIR_BASE=build/subdirectory || failure "Failed to build with BUILD_DIR_BASE as subdir" make BUILD_DIR_BASE=build/subdirectory || failure "Failed to build with BUILD_DIR_BASE as subdir"
NEW_BUILD_FILES=$(find ${BUILD}/subdirectory -type f) NEW_BUILD_FILES=$(find ${BUILD}/subdirectory -type f)
if [ -z "${NEW_BUILD_FILES}" ]; then if [ -z "${NEW_BUILD_FILES}" ]; then
failure "No files found in new build directory!" failure "No files found in new build directory!"
fi fi
print_status "Can still clean build if all text files are CRLFs" print_status "Can still clean build if all text files are CRLFs"
make clean || failure "Unexpected failure to make clean" make clean || failure "Unexpected failure to make clean"
find . -exec unix2dos {} \; # CRLFify template dir find . -exec unix2dos {} \; # CRLFify template dir
# make a copy of esp-idf and CRLFify it # make a copy of esp-idf and CRLFify it
CRLF_ESPIDF=${TESTDIR}/esp-idf-crlf CRLF_ESPIDF=${TESTDIR}/esp-idf-crlf
mkdir -p ${CRLF_ESPIDF} mkdir -p ${CRLF_ESPIDF}
cp -rv ${IDF_PATH}/* ${CRLF_ESPIDF} cp -rv ${IDF_PATH}/* ${CRLF_ESPIDF}
# don't CRLFify executable files, as Linux will fail to execute them # don't CRLFify executable files, as Linux will fail to execute them
find ${CRLF_ESPIDF} -type f ! -perm 755 -exec unix2dos {} \; find ${CRLF_ESPIDF} -type f ! -perm 755 -exec unix2dos {} \;
make IDF_PATH=${CRLF_ESPIDF} || failure "Failed to build with CRLFs in source" make IDF_PATH=${CRLF_ESPIDF} || failure "Failed to build with CRLFs in source"
# do the same checks we do for the clean build # do the same checks we do for the clean build
assert_built ${APP_BINS} ${BOOTLOADER_BINS} partitions_singleapp.bin assert_built ${APP_BINS} ${BOOTLOADER_BINS} partitions_singleapp.bin
[ -f ${BUILD}/partition*.bin ] || failure "A partition table should have been built in CRLF mode" [ -f ${BUILD}/partition*.bin ] || failure "A partition table should have been built in CRLF mode"
print_status "All tests completed" print_status "All tests completed"
if [ -n "${FAILURES}" ]; then if [ -n "${FAILURES}" ]; then
echo "Some failures were detected:" echo "Some failures were detected:"
echo -e "${FAILURES}" echo -e "${FAILURES}"
exit 1 exit 1
else else
echo "Build tests passed." echo "Build tests passed."
fi fi
} }
function print_status() function print_status()
{ {
echo "******** $1" echo "******** $1"
STATUS="$1" STATUS="$1"
} }
function failure() function failure()
{ {
echo "!!!!!!!!!!!!!!!!!!!" echo "!!!!!!!!!!!!!!!!!!!"
echo "FAILURE: $1" echo "FAILURE: $1"
echo "!!!!!!!!!!!!!!!!!!!" echo "!!!!!!!!!!!!!!!!!!!"
FAILURES="${FAILURES}${STATUS} :: $1\n" FAILURES="${FAILURES}${STATUS} :: $1\n"
} }
TESTDIR=${TMP}/build_system_tests_$$ TESTDIR=${TMP}/build_system_tests_$$
@ -164,62 +164,62 @@ BUILD=${TESTDIR}/template/build
# copy all the build output to a snapshot directory # copy all the build output to a snapshot directory
function take_build_snapshot() function take_build_snapshot()
{ {
rm -rf ${SNAPSHOT} rm -rf ${SNAPSHOT}
cp -ap ${TESTDIR}/template/build ${SNAPSHOT} cp -ap ${TESTDIR}/template/build ${SNAPSHOT}
} }
# verify that all the arguments are present in the build output directory # verify that all the arguments are present in the build output directory
function assert_built() function assert_built()
{ {
until [ -z "$1" ]; do until [ -z "$1" ]; do
if [ ! -f "${BUILD}/$1" ]; then if [ ! -f "${BUILD}/$1" ]; then
failure "File $1 should be in the build output directory" failure "File $1 should be in the build output directory"
fi fi
shift shift
done done
} }
# Test if a file has been rebuilt. # Test if a file has been rebuilt.
function file_was_rebuilt() function file_was_rebuilt()
{ {
# can't use [ a -ot b ] here as -ot only gives second resolution # can't use [ a -ot b ] here as -ot only gives second resolution
# but stat -c %y seems to be microsecond at least for tmpfs, ext4.. # but stat -c %y seems to be microsecond at least for tmpfs, ext4..
if [ "$(stat -c %y ${SNAPSHOT}/$1)" != "$(stat -c %y ${BUILD}/$1)" ]; then if [ "$(stat -c %y ${SNAPSHOT}/$1)" != "$(stat -c %y ${BUILD}/$1)" ]; then
return 0 return 0
else else
return 1 return 1
fi fi
} }
# verify all the arguments passed in were rebuilt relative to the snapshot # verify all the arguments passed in were rebuilt relative to the snapshot
function assert_rebuilt() function assert_rebuilt()
{ {
until [ -z "$1" ]; do until [ -z "$1" ]; do
assert_built "$1" assert_built "$1"
if [ ! -f "${SNAPSHOT}/$1" ]; then if [ ! -f "${SNAPSHOT}/$1" ]; then
failure "File $1 should have been original build snapshot" failure "File $1 should have been original build snapshot"
fi fi
if ! file_was_rebuilt "$1"; then if ! file_was_rebuilt "$1"; then
failure "File $1 should have been rebuilt" failure "File $1 should have been rebuilt"
fi fi
shift shift
done done
} }
# verify all the arguments are in the build directory & snapshot, # verify all the arguments are in the build directory & snapshot,
# but were not rebuilt # but were not rebuilt
function assert_not_rebuilt() function assert_not_rebuilt()
{ {
until [ -z "$1" ]; do until [ -z "$1" ]; do
assert_built "$1" assert_built "$1"
if [ ! -f "${SNAPSHOT}/$1" ]; then if [ ! -f "${SNAPSHOT}/$1" ]; then
failure "File $1 should be in snapshot build directory" failure "File $1 should be in snapshot build directory"
fi fi
if file_was_rebuilt "$1"; then if file_was_rebuilt "$1"; then
failure "File $1 should not have been rebuilt" failure "File $1 should not have been rebuilt"
fi fi
shift shift
done done
} }
cd ${TESTDIR} cd ${TESTDIR}